part of discord_dart;

class Client {
  Map _defaultOptions = {
    "bot": true,
    "internal": {
      "ws": {"large_threshold": 100}
    }
  };

  Map _handlers = {
    "ready": [], 
    "message": []
  };

  var _socket;
  String token;

  int _lastS = null;

  Map options;

  _handleMsg(msg) {
    //print('Message received: $msg');
    var json = JsonCodec().decode(msg);

    if (json['s'] != null) {
      this._lastS = json['s'];
    }

    //const ms = const JSON.decode(msg)["d"]["heartbeat_interval"];

    if (json["op"] == 10) {
      this._socket.add(JsonCodec().encode({
        "op": 2,
        "d": {
          "token": this.token,
          "properties": {
            "\$browser": "Discord Dart"
          },
          "large_threshold": this.options['internal']['ws']['large_threshold'],
          "compress": false
        }
      }));
    }
  }

  Client(String token) {
    this.options = this._defaultOptions..addAll(options);
   
    WebSocket.connect('wss://gateway.discord.gg?v=6&encoding=json').then((socket) {
      this._socket = socket;
      this._socket.listen(this._handleMsg);
    });
  }
}